Wayland Window functions.
Ecore » Ecore_Wayland - Wayland integration

Functions that can be used to create a Wayland window. More...

## Functions

EAPI Ecore_Wl_Window * | ecore_wl_window_new (Ecore_Wl_Window *parent, int x, int y, int w, int h, int buffer_type)
| Creates a new window.
EAPI void | ecore_wl_window_free (Ecore_Wl_Window *win)
| Deletes the given window.
EAPI void | ecore_wl_window_move (Ecore_Wl_Window *win, int x, int y)
| Signals for Wayland to initiate a window move.
EAPI void | ecore_wl_window_resize (Ecore_Wl_Window *win, int w, int h, int location)
| Signals for Wayland to initiate a window resize.
EAPI void | ecore_wl_window_show (Ecore_Wl_Window *win)
| Shows a window.
EAPI void | ecore_wl_window_hide (Ecore_Wl_Window *win)
| Hides a window.
EAPI void | ecore_wl_window_raise (Ecore_Wl_Window *win)
| Raises a window.
EAPI void | ecore_wl_window_iconified_set (Ecore_Wl_Window *win, Eina_Bool iconified)
| Iconifies a window.
EAPI struct wl_surface * | ecore_wl_window_surface_create (Ecore_Wl_Window *win)
| Returns a wl_surface with no association to any wl_shell_surface.
EAPI Ecore_Wl_Window * | ecore_wl_window_surface_find (struct wl_surface *surface)
| Returns the Ecore_Wl_Window from a wl_surface.
EAPI void | ecore_wl_window_input_region_set (Ecore_Wl_Window *win, int x, int y, int w, int h)
| Sets the input region of the Ecore_Wl_Window.
EAPI void | ecore_wl_window_opaque_region_set (Ecore_Wl_Window *win, int x, int y, int w, int h)
| Sets the opaque region of the Ecore_Wl_Window.
EAPI void | ecore_wl_window_rotation_set (Ecore_Wl_Window *win, int rotation)
| Sets the rotation of the Ecore_Wl_Window.
EAPI int | ecore_wl_window_rotation_get (Ecore_Wl_Window *win)
| Gets the rotation of the Ecore_Wl_Window.

## Detailed Description

Functions that can be used to create a Wayland window.

## Function Documentation

## ecore_wl_window_new()

EAPI Ecore_Wl_Window * ecore_wl_window_new | ( | Ecore_Wl_Window * | parent,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | int | buffer_type )

Creates a new window.

Parameters

  parent | The parent window to use. If `parent` is `0`, the root window of the default display is used.
  x | X Position
  y | Y position
  w | Width
  h | Height
  buffer_type | The type of the buffer to be used to create a new Ecore_Wl_Window.

Returns
  The new window, or NULL on failure

Since
  1.2

References EINA_FALSE, eina_hash_add(), and ERR.

## ecore_wl_window_free()

EAPI void ecore_wl_window_free | ( | Ecore_Wl_Window * | win | ) |

Deletes the given window.

Parameters

  win | The given window

Since
  1.2

References ecore_timer_del(), eina_hash_del(), EINA_INLIST_FOREACH, EINA_SAFETY_ON_NULL_RETURN, and eina_stringshare_del().

## ecore_wl_window_move()

EAPI void ecore_wl_window_move | ( | Ecore_Wl_Window * | win,
|  | int | x,
|  | int | y )

Signals for Wayland to initiate a window move.

The position requested (`x`, `y`) is not honored by Wayland because Wayland does not allow specific window placement to be set.

Parameters

  win | The window to move.
  x | X Position
  y | Y Position

Since
  1.2

References EINA_SAFETY_ON_NULL_RETURN.

## ecore_wl_window_resize()

EAPI void ecore_wl_window_resize | ( | Ecore_Wl_Window * | win,
|  | int | w,
|  | int | h,
|  | int | location )

Signals for Wayland to initiate a window resize.

The size requested (`w`, `h`) is not honored by Wayland because Wayland does not allow specific window sizes to be set.

Parameters

  win | The window to resize.
  w | Width
  h | Height
  location | The edge of the window from where the resize should start.

Since
  1.2

References EINA_SAFETY_ON_NULL_RETURN, and EINA_UNUSED.

## ecore_wl_window_show()

EAPI void ecore_wl_window_show | ( | Ecore_Wl_Window * | win | ) |

Shows a window.

Synonymous to "mapping" a window in Wayland System terminology.

Parameters

  win | The window to show.

Since
  1.2

References ecore_wl_window_surface_create().

## ecore_wl_window_hide()

EAPI void ecore_wl_window_hide | ( | Ecore_Wl_Window * | win | ) |

Hides a window.

Synonymous to "unmapping" a window in Wayland System terminology.

Parameters

  win | The window to hide.

Since
  1.2

References EINA_SAFETY_ON_NULL_RETURN.

## ecore_wl_window_raise()

EAPI void ecore_wl_window_raise | ( | Ecore_Wl_Window * | win | ) |

Raises a window.

Parameters

  win | The window to raise.

Since
  1.2

References EINA_SAFETY_ON_NULL_RETURN.

## ecore_wl_window_iconified_set()

EAPI void ecore_wl_window_iconified_set | ( | Ecore_Wl_Window * | win,
|  | Eina_Bool | iconified )

Iconifies a window.

Parameters

  win | The window to iconifiy

Since
  1.12

References EINA_SAFETY_ON_NULL_RETURN.

## ecore_wl_window_surface_create()

EAPI struct wl_surface * ecore_wl_window_surface_create | ( | Ecore_Wl_Window * | win | ) |

Returns a wl_surface with no association to any wl_shell_surface.

Parameters

  win | The window which will use this newly created surface.

Returns
  wl_surface or NULL on error

Since
  1.8

References EINA_SAFETY_ON_NULL_RETURN_VAL.

Referenced by ecore_wl_window_show().

## ecore_wl_window_surface_find()

EAPI Ecore_Wl_Window * ecore_wl_window_surface_find | ( | struct wl_surface * | surface | ) |

Returns the Ecore_Wl_Window from a wl_surface.

Parameters

  surface | The surface for which to find the Ecore_Wl_Window from

Returns
  the Ecore_Wl_Window associated with this surface, or NULL if not found

Since
  1.8

References eina_hash_iterator_data_new(), eina_iterator_free(), eina_iterator_next(), and EINA_SAFETY_ON_NULL_RETURN_VAL.

## ecore_wl_window_input_region_set()

EAPI void ecore_wl_window_input_region_set | ( | Ecore_Wl_Window * | win,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h )

Sets the input region of the Ecore_Wl_Window.

To set an empty region, pass width and height as 0.

An empty input region means the entire window surface will accept input.

Parameters

  win | The window
  x | The left point of the region.
  y | The top point of the region.
  w | The width of the region.
  h | The height of the region.

Since
  1.8

References EINA_SAFETY_ON_NULL_RETURN.

## ecore_wl_window_opaque_region_set()

EAPI void ecore_wl_window_opaque_region_set | ( | Ecore_Wl_Window * | win,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h )

Sets the opaque region of the Ecore_Wl_Window.

Parameters

  win | The window
  x | The left point of the region.
  y | The top point of the region.
  w | The width of the region.
  h | The height of the region.

Since
  1.8

References EINA_SAFETY_ON_NULL_RETURN.

## ecore_wl_window_rotation_set()

EAPI void ecore_wl_window_rotation_set | ( | Ecore_Wl_Window * | win,
|  | int | rotation )

Sets the rotation of the Ecore_Wl_Window.

Parameters

  win | The window
  rotation | The degree of rotation for this window

Since
  1.8

References EINA_SAFETY_ON_NULL_RETURN.

## ecore_wl_window_rotation_get()

EAPI int ecore_wl_window_rotation_get | ( | Ecore_Wl_Window * | win | ) |

Gets the rotation of the Ecore_Wl_Window.

Parameters

  win | The window

Returns
  The degree of rotation for this window

Since
  1.8

References EINA_SAFETY_ON_NULL_RETURN_VAL.